<?php
define("SERVERDATA_EXECCOMMAND",2);
define("SERVERDATA_AUTH",3);
class RCon {
    var $Password;
    var $Host;
    var $Port;
    var $_Sock = null;
    var $_Id = 0;

    function RCon ($Host,$Port,$Password) {
   $this->Password = $Password;
   $this->Host = $Host;
   $this->Port = $Port;
   $this->_Sock = @fsockopen($this->Host,$this->Port, $errno, $errstr, 30) or
       die("StatusPHPError: $errstr ($errno)\n");
   $this->_Set_Timeout($this->_Sock,2,500);
    }
   
    function Auth () {
   $PackID = $this->_Write(SERVERDATA_AUTH,$this->Password);
   
   $ret = $this->_PacketRead();
   if ($ret[1]['id'] == -1) {
       die("Erreur\n");
   }
    }

    function _Set_Timeout(&$res,$s,$m=0) {
   if (version_compare(phpversion(),'4.3.0','<')) {
       return socket_set_timeout($res,$s,$m);
   }
   return stream_set_timeout($res,$s,$m);
    }

    function _Write($cmd, $s1='', $s2='') {
   $id = ++$this->_Id;
   $data = pack("VV",$id,$cmd).$s1.chr(0).$s2.chr(0);
   $data = pack("V",strlen($data)).$data;
   fwrite($this->_Sock,$data,strlen($data));
   return $id;
    }

    function _PacketRead() {
   $retarray = array();
   while ($size = @fread($this->_Sock,4)) {
       $size = unpack('V1Size',$size);
       if ($size["Size"] > 4096) {
      $packet = "\x00\x00\x00\x00\x00\x00\x00\x00".fread($this->_Sock,4096);
       } else {
      $packet = fread($this->_Sock,$size["Size"]);
       }
       array_push($retarray,unpack("V1ID/V1Reponse/a*S1/a*S2",$packet));
   }
   return $retarray;
    }

    function Read() {
   $Packets = $this->_PacketRead();
   foreach($Packets as $pack) {
       if (isset($ret[$pack['ID']])) {
      $ret[$pack['ID']]['S1'] .= $pack['S1'];
      $ret[$pack['ID']]['S2'] .= $pack['S1'];
       } else {
      $ret[$pack['ID']] = array(
               'Reponse' => $pack['Reponse'],
               'S1' => $pack['S1'],
               'S2' =>   $pack['S2'],
                );
       }
   }
   return $ret;
    }

    function sendCommand($Command) {
   $Command = '"'.trim(str_replace(' ','" "', $Command)).'"';
   $this->_Write(SERVERDATA_EXECCOMMAND,$Command,'');
    }

    function rconCommand($Command) {
   $this->sendcommand($Command);
   $ret = $this->Read();
   return $ret[2]['S1'];
    }
}

/// Execution of Functions

 // Rcon Commands
    $r = new rcon($IP,$Port,$Pass);
   $r->Auth();
   $information = $r->rconCommand("status");

/*
   // Find reserved slot number
   $information2 = $r->rconCommand("reservedslot");
   $information2 = ltrim($information2, "\"reservedslot\" = \"");
   $information2 = explode("\"", $information2);
   $server["reserved"] = $information2[0];
*/
   

   $info = explode("#", $information);
   $server = array();
   // Grab server info line, explode by : and assign variables
   $server["max"] = $servermax; // Set max players (I'm Lazy, didn't extract from string)
   $serverinfo = explode(":", $info[0]);
   $server["curplayers"] = substr_count($information, "#") - 1;
   $server["name"] = rtrim($serverinfo[1], " version");
   $server["ip"] = $serverinfo[3]; // Add this to get port .":".rtrim($serverinfo[4], " map")
   // Explode [5](map field) because it has an "at" on the end of it and the rtrim
   // will take out the "t" in ctf_2fort for some odd reason
   $grabmap = explode(" ", $serverinfo[5]);
   $server["map"] = $grabmap[1];
   
   // Start extracting player info from the arrays exploded by the "#" sign
$i = 2; // Start at 2nd "#", first is server info 2nd is header of player list info
$exit = $server["curplayers"] + 1; // Add 1 more to the count because of the extra player header
$players = array();
$player = array();
while ($i <= $exit)
{
   $tmp = $info[$i];
   // Check if the explode by "#" was messed up due to it being in a player name and fix it
   if ($poundfound) {
      //Subtract one from current players on server due to flaw in counting current players
      //by the number of #'s
      $server["curplayers"] = $server["curplayers"] - 1;
      // Call previous line to extract the first part of their name before the #
      $ptmp = $info[$i - 1];
      $begin = 0;
      $end = strrpos($ptmp, "\"");
      $player["name"] = trim(substr($ptmp, $end + 1));
      // Call current part to get their name after the #
      $begin = 0;
      $end = strrpos($tmp, "\"");
      //Combine both and add the # back into the name
      $player["name"] = $player["name"]."#".addslashes(substr($tmp, $begin, $end - $begin));
      $tmp = trim(substr($tmp, $end + 1));
   } else { // If no # was found in last explode
      //name
      $begin = strpos($tmp, "\"") + 1;
      $end = strrpos($tmp, "\"");
      $player["name"] = addslashes(substr($tmp, $begin, $end - $begin));
      $tmp = trim(substr($tmp, $end + 1));
   }
      
   // steamid
   $end = strpos($tmp, " ");
    $player["steamid"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
      
   //Time
    $end = strpos($tmp, " ");
    $player["time"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
      
   //Ping
    $end = strpos($tmp, " ");
    $player["ping"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
      
   //Loss
    $end = strpos($tmp, " ");
    $player["loss"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
      
   //State (active/inactive)
    $end = strpos($tmp, " ");
    $player["state"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
      
   //IP
   $end = strpos($tmp, ":");
    $player["ip"] = substr($tmp, 0, $end);
    $tmp = trim(substr($tmp, $end));
   /* Display all info
   echo "<br>Name: ".$player["name"];
   echo "<br>SteamID: ".$player["id"];
   echo "<br>Time Connected: ".$player["time"];
   echo "<br>Ping: ".$player["ping"];
   echo "<br>Loss: ".$player["loss"];
   echo "<br>State: ".$player["state"];
   echo "<br>IP: ".$player["ip"];
   */
   
   if ($poundfound) {
      $poundfound = false;
   }
   if ($player['steamid']) {
      $players[] = $player;
      $i = $i + 1;
   } else {
      $i = $i + 1;
      $poundfound = $player['name'];
   }
   
}
?>